/*
 * Copyright (C) 2003 Lars Knoll (knoll@kde.org)
 *
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

/* This file is mostly data generated by flex. Unfortunately flex
   can't handle 16bit strings directly, so we just copy the part of
   the code we need and modify it to our needs.

   Most of the defines below are to make sure we can easily use the
   flex generated code, using as little editing as possible.

   The flex syntax to generate the lexer are more or less directly
   copied from the CSS2.1 specs, with some fixes for comments and
   the important symbol.

   To regenerate, run flex on tokenizer.flex. After this, copy the
   data tables and the YY_DECL method over to this file. Remove the
   init code from YY_DECL and change the YY_END_OF_BUFFER to only call
   yyterminate().

*/

// --------- begin generated code -------------------


#include "CSSGrammar.h"

#define INITIAL 0
#define mediaquery 1
#define forkeyword 2

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined __STDC_VERSION__ && __STDC_VERSION__ >= 199901L
#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t;
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;
#endif /* ! C99 */
#define YY_NUM_RULES 69
#define YY_END_OF_BUFFER 70
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[482] =
    {   0,
        0,    0,    0,    0,    0,    0,   70,   68,    2,    2,
       68,   68,   68,   68,   68,   68,   68,   68,   68,   68,
       57,   68,   68,   15,   15,   15,   68,   68,   68,   68,
       67,   15,   15,   15,   66,   15,    2,    0,    0,    0,
       14,    0,    0,    0,   18,   18,    0,    8,    0,    0,
        9,    0,   16,    0,   15,   15,   15,    0,   58,    0,
       56,    0,    0,   57,   55,   55,   55,   55,   55,   55,
       55,   55,   55,   16,   55,   55,   52,   55,    0,   55,
        0,    0,   35,   35,   35,   35,   35,   35,   35,    0,
       63,   15,    0,    0,   15,   15,    0,   15,   15,   15,

        7,    6,    5,   15,   15,   15,   15,    0,    0,    0,
       14,    0,    0,    0,   18,   18,    0,   18,   18,    0,
        0,   14,    0,    0,    4,   15,    0,    0,   55,    0,
       42,   55,   37,   40,   55,   53,   44,   55,   43,   51,
       55,   46,   45,   41,   55,   55,   55,   55,   55,   55,
        0,   35,   35,    0,   35,   35,   35,   35,   35,   35,
       35,   35,   15,   15,   16,   15,   15,   64,   64,   15,
       15,   12,   10,   15,   13,    0,    0,    0,   17,   17,
       18,   18,   18,    0,    0,   15,    0,    1,   55,   55,
       47,   55,   54,   16,   48,   38,   55,   55,   55,    3,

       35,   35,   35,   35,   35,   35,   35,   35,   35,   35,
       15,   59,    0,   64,   64,   64,   63,   15,   11,    0,
        0,    0,   18,   18,   18,    0,   15,    0,    0,   55,
       49,   50,   55,   55,   35,   35,   35,   35,   35,   35,
       35,   20,   35,   15,   65,   64,   64,   64,   64,    0,
        0,    0,    0,   61,    0,   15,    0,    0,    0,   18,
       18,   18,    0,   15,   55,   55,   39,   35,   35,   35,
       35,   35,   21,   35,   35,   15,   65,   64,   64,   64,
       64,   64,    0,    0,    0,    0,    0,    0,    0,    0,
        0,   61,    0,    0,   15,    0,    0,   17,   17,   18,

       18,    0,   15,   55,   55,   35,   35,   35,   35,   19,
       35,   35,   15,   65,   64,   64,   64,   64,   64,   64,
        0,   60,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,   15,    0,    0,   18,   18,    0,   15,
       55,   55,   35,   35,   23,   35,   35,   35,   15,   65,
       64,   64,   64,   64,   64,   64,   64,    0,   60,    0,
        0,    0,   60,    0,    0,    0,    0,   18,   15,   55,
       35,   35,   35,   35,   65,    0,    0,    0,   36,   15,
       35,   35,   35,   35,   35,   35,   22,   24,   65,    0,
        0,    0,   15,   35,   35,   35,   35,   35,   35,    0,

        0,    0,   63,   35,   35,   35,   35,   35,   35,   35,
       35,    0,    0,    0,    0,    0,    0,   35,   35,   35,
       35,   25,   35,   35,   35,    0,   62,    0,    0,    0,
        0,   26,   35,   35,   35,   35,   27,   35,    0,    0,
        0,    0,   31,   35,   35,   35,   35,    0,    0,    0,
       35,   35,   35,   35,    0,    0,   35,   35,   29,   35,
        0,    0,   35,   33,   35,   30,    0,    0,   35,   28,
       35,    0,   35,   35,   35,   35,   34,   35,   35,   32,
        0
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    4,    5,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    6,    7,    8,    9,   10,   11,   12,   13,   14,
       15,   16,   17,   12,   18,   19,   20,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   12,   22,   23,
       24,   25,   26,   27,   28,   29,   30,   31,   32,   33,
       34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
       44,   45,   46,   47,   48,   49,   50,   51,   52,   53,
       12,   54,   12,   55,   56,   12,   57,   58,   59,   60,

       61,   62,   63,   64,   65,   37,   66,   67,   68,   69,
       70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
       80,   81,   82,   83,   12,   84,    1,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,

       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85
    } ;

static yyconst flex_int32_t yy_meta[86] =
    {   0,
        1,    2,    3,    4,    4,    5,    6,    7,    6,    6,
        6,    6,    7,    8,    9,    6,    6,   10,    6,    6,
       11,    6,    6,    6,    6,   12,    6,   13,   13,   13,
       13,   13,   13,   14,   14,   14,   14,   14,   14,   14,
       14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
       14,   14,   14,   14,    6,   14,   13,   13,   13,   13,
       13,   13,   14,   14,   14,   14,   14,   14,   14,   14,
       14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
       14,    6,    6,    6,   14
    } ;

static yyconst flex_int16_t yy_base[553] =
    {   0,
        0,    0,   64,   66,   54,   56, 1486, 6578,   93,   98,
      107,   83,  155, 1460,   77, 1459,   98,   99, 1446, 1449,
      207, 1454,  275,  100,  108,  146,  326, 1402, 1384, 1380,
     6578,  101,  110,  151, 6578,  127,  227,  295,   89,  136,
     6578,  387,  140,    0,  429, 1346,  471, 6578,  117,  532,
     6578,  138,  157, 1371,  142,  295,  307,  574,  283, 1379,
     1371, 1325, 1324,    0, 1290,  249,  150,  274,   93,  241,
      152,  256,  325,  309,  347,  313, 1289,  147,  616,  154,
     1322,  346, 1285,  284,  281,  357,  348,  170,  279,  658,
     6578,  208,  700, 1317,  389,  358, 1310,  399,  276,  761,

     6578, 6578, 6578,  409,  367,  413,  420,  307,  427,  374,
      421,  822,  883,    0, 1254,  925,  967, 1249, 1028,  319,
      451,  465, 1089, 1150, 6578,  456, 1282,  183, 1233, 1192,
     1224,  443, 1184, 1165,  454, 1161, 1149,  441, 1141, 1131,
      383, 1082, 1060, 1047,  453,  458,  470, 1029, 1253,  494,
     1044,  464,  999, 1295,  492,  486,  496,  516,  504,  517,
      998, 1356,  417, 1417, 1019,  418,  422,  491,  997,  502,
     1459,  527,  528,  545,  554,  409,  515, 1520,    0, 1562,
      965, 1623, 1684,  570, 1745,  560,  994, 6578,  948, 1806,
      935,  556,  923,  500,  897,  896,  559, 1848,  569, 6578,

      598,  882, 1909,  566,  565,  587,  606,  589,  631, 1951,
     2012, 6578,    0,  559,  907,  902,  691, 2054,  561,  593,
     2115,    0, 2157, 2218, 2279, 2340,  644,  878,  346, 2401,
      839,  836, 2443,  613,  616, 2504,  668,  534,  610,  656,
      680,  820, 2546, 2607,    0,  591,  847,  844,  803,  733,
      793,  614,  605, 6578, 2668, 2710,  625, 2771,    0, 2813,
     2874, 2935, 2996, 3057, 3131, 3173, 3234,  714, 3295,  695,
      690,  727,  762,  729, 3337, 3398,    0,  643,  777,  744,
      699,  698,  829,  654,  834, 3459,  689, 3520,  854,  894,
      915,  920, 3581, 3642, 3684,  683, 3745, 6578,  597, 3806,

     3867, 3928, 3989, 4050, 4111,  730, 4172,  814,  719,  542,
      750, 4214, 4275,    0,  762,  558,  553,  552,  531,  447,
      860, 6578,  697,  838,  957, 4336, 4397,  699,  926,  988,
     4458, 4519, 4580, 1002,  744, 1010, 4622, 4664, 1042,  737,
     4706, 4767,  647, 4828,  402,  818,  848, 1069, 1033,    0,
      437, 6578, 6578, 6578, 6578, 6578, 6578, 1122,  898,  924,
     4870, 1162,  963,  968, 4912, 4973,  770, 1063,  877, 1074,
     5005, 1102,  989, 1009,    0, 5062, 5104, 5146, 6578, 1036,
     1079, 1080, 1081, 1084, 1130,  910,  353,  315, 6578, 5188,
     5230, 5272,  689, 1139,  895, 1085, 1090, 1119, 1160, 5314,

     5356, 1226, 1242, 1120, 1152, 1164, 1207, 1208, 1210, 1219,
     1234, 1327, 1287, 1316, 1345, 1388, 5398, 1263, 1225, 1116,
     1211,  252, 1247, 1243, 1248, 1363, 6578, 1428, 5440, 1449,
     5501,  242, 1310, 1318, 1329,  856,  180,  813, 1454, 5562,
     1491, 5604,  148, 1357, 1326, 1061, 1370, 1531, 5646, 5688,
     1344, 1374, 1427, 1375, 5730, 5772, 1453, 1456,  135, 1458,
     5814, 5856, 1457,   97, 1183,  955, 5898, 1552, 1490,   91,
     1408, 1557, 1373, 1409, 1412, 1455,   78, 1530, 1522,   39,
     6578, 5959, 5964, 5977, 5982, 5987, 5994, 6004, 6017,  758,
     6022, 6032, 6045, 6059,  362, 6064, 6074, 6079, 6089, 6099,

     6103,  798, 6112, 6125, 6138, 6152, 6166, 6176, 6186, 6191,
     6203,  799, 6217,  957, 6222, 6234, 6247, 1071, 6261, 1086,
     6266, 6278, 6291, 6304, 6317, 6330, 1087, 6335, 6348, 1179,
     6353, 6365, 6378, 6391, 6404, 6417, 6430, 6435, 6448, 1183,
     6453, 6465, 6478, 6491, 6504, 6517, 1189, 1223, 6530, 6543,
     6553, 6563
    } ;

static yyconst flex_int16_t yy_def[553] =
    {   0,
      481,    1,    1,    1,    1,    1,  481,  481,  481,  481,
      481,  482,  483,  481,  484,  481,  481,  485,  481,  481,
      481,  481,  486,  487,  487,  487,  488,  481,  481,  481,
      481,  487,  487,  487,  481,  487,  481,  481,  481,  482,
      481,  489,  483,  490,  491,  491,  492,  481,  484,  493,
      481,  481,  481,  481,  487,  487,  487,  488,   21,  494,
      481,  495,  481,   21,  496,  496,  496,  496,  496,  496,
      496,  496,  496,  496,  496,  496,  496,  496,  497,  496,
      481,  486,  498,  498,  498,  498,  498,  498,  498,  499,
      481,  487,  500,  481,  487,  487,  501,  487,  487,  487,

      481,  481,  481,  487,  487,  487,  487,  481,  482,  482,
      482,  482,  489,  502,  491,  491,  503,  491,  116,  504,
      504,  504,  504,  505,  481,  487,  506,  507,  496,  508,
      496,  496,  496,  496,  496,  496,  496,  496,  496,  496,
      496,  496,  496,  496,  496,  496,  496,  496,  496,  496,
      481,  498,  498,  509,  498,  498,  498,  498,  498,  498,
      498,  498,  487,  100,  481,  487,  487,  510,  481,  487,
      100,  487,  487,  487,  487,  481,  511,  511,  512,  116,
      491,  116,  116,  504,  504,  487,  513,  481,  496,  149,
      496,  496,  496,  496,  496,  496,  496,  149,  496,  481,

      498,  498,  162,  498,  498,  498,  498,  498,  498,  162,
      100,  481,  514,  515,  481,  481,  516,  100,  487,  481,
      517,  518,  116,  116,  116,  504,  487,  513,  519,  149,
      496,  496,  149,  496,  498,  162,  498,  498,  498,  498,
      498,  498,  162,  100,  520,  521,  481,  481,  481,  522,
      522,  523,  524,  481,  525,  100,  481,  526,  527,  528,
      528,  261,  529,  100,  149,  149,  149,  498,  162,  498,
      498,  498,  498,  498,  162,  100,  530,  531,  481,  481,
      481,  481,  481,  523,  481,  532,  533,  534,  535,  535,
      535,  535,  535,  536,  100,  481,  537,  481,  538,  538,

      300,  539,  100,  149,  304,  498,  162,  498,  498,  498,
      498,  162,  100,  540,  541,  481,  481,  481,  481,  481,
      481,  481,  542,  542,  542,  542,  543,  544,  544,  544,
      544,  545,  546,  303,  481,  537,  300,  301,  539,  303,
      304,  304,  498,  162,  498,  498,  498,  498,  303,  547,
      481,  481,  481,  481,  481,  481,  481,  542,  542,  542,
      326,  544,  544,  544,  331,  546,  481,  338,  303,  342,
      498,  498,  498,  498,  548,  326,  331,  366,  481,  303,
      498,  498,  498,  498,  498,  498,  498,  498,  481,  326,
      331,  366,  303,  498,  498,  498,  498,  498,  498,  326,

      331,  546,  549,  498,  498,  498,  498,  498,  498,  498,
      498,  542,  544,  549,  549,  550,  551,  498,  498,  498,
      498,  498,  498,  498,  498,  481,  481,  550,  552,  550,
      550,  498,  498,  498,  498,  498,  498,  498,  550,  431,
      550,  431,  498,  498,  498,  498,  498,  550,  440,  431,
      498,  498,  498,  498,  440,  431,  498,  498,  498,  498,
      440,  431,  498,  498,  498,  498,  440,  550,  498,  498,
      498,  550,  498,  498,  498,  498,  498,  498,  498,  498,
        0,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481
    } ;

static yyconst flex_int16_t yy_nxt[6664] =
    {   0,
        8,    9,   10,    9,    9,    9,   11,   12,   13,   14,
        8,    8,   15,    8,    8,   16,   17,   18,   19,   20,
       21,    8,   22,    8,    8,    8,   23,   24,   24,   24,
       24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
       25,   24,   24,   24,   24,   24,   24,   26,   24,   24,
       24,   24,   24,   27,   28,   24,   24,   24,   24,   24,
       24,   24,   24,   24,   24,   24,   24,   24,   25,   24,
       24,   24,   24,   24,   24,   26,   24,   24,   24,   24,
       24,    8,   29,   30,   24,   31,   36,   31,   36,   41,
       41,   32,  154,   32,   37,   37,   37,   37,   37,   37,

       37,   37,   37,   37,   33,   34,   33,   34,   38,   38,
       38,   38,   38,   91,   91,   36,   54,   36,   52,   52,
       32,   91,   32,   91,   94,   95,   94,   95,  108,   41,
       50,  154,   33,   34,   33,   34,   42,  135,   53,   56,
       91,  104,   39,   41,  154,   35,  130,   35,   57,   96,
      154,  105,   58,   93,   93,   91,  108,  481,   52,   91,
      481,   93,   97,   93,   91,  135,   53,   56,  107,  104,
       50,   39,   43,   94,   94,   44,   57,   96,   53,  105,
       93,  132,   45,   45,   45,   45,   45,   45,  154,   42,
       98,  106,  137,   47,  147,   93,  107,  159,  128,   93,

      130,  154,  188,  130,   93,  130,   53,  130,   47,  150,
      132,   45,   45,   45,   45,   45,   45,   61,   98,  106,
      137,   91,  147,  154,   62,   63,  159,   64,   37,   37,
       37,   37,   37,  154,   65,   65,   66,   67,   68,   65,
       69,   70,   71,   65,   72,   65,   73,   74,   65,   75,
       65,   76,   77,   78,   65,   65,   65,   65,   65,   65,
       79,   93,   80,   65,   65,   66,   67,   68,   65,   69,
       70,   71,   72,   65,   73,   74,   65,   75,   65,   76,
       77,   78,   65,   65,   65,   65,   65,   65,  131,   91,
      138,   65,   82,  136,  130,  154,   38,   38,   38,   38,

       38,  481,  130,   59,   84,  154,  160,   85,   91,  130,
       86,   94,   95,  133,   87,   88,  131,   89,  155,  138,
       91,  136,  156,   65,  134,   94,  141,  130,   90,   93,
       39,   41,  154,   84,  154,  160,   85,  154,  126,   86,
      145,  133,   87,   88,  146,   89,  100,  155,   93,  176,
      156,   65,  134,  100,  100,  100,  100,  100,  100,   39,
       93,  229,  130,  481,  139,  188,  130,  126,  154,  145,
      140,   91,   50,  146,   65,   65,  142,  176,  130,  158,
       91,   41,  100,  100,  100,  100,  100,  100,   40,   40,
       40,  109,  139,  143,  111,  152,  157,  144,  140,   90,

      130,  154,   91,  194,  167,  142,  154,  112,  158,  166,
      154,   93,   91,  173,  112,  112,  112,  112,  112,  112,
       93,  143,   91,  152,  157,  144,   91,   42,   41,   40,
       91,   91,  167,   91,   41,  212,  130,  170,  166,  172,
      113,  173,   93,  112,  112,  112,  112,  112,  112,  116,
      220,  174,   93,  481,  213,  154,  116,  116,  116,  116,
      116,  116,   93,   41,  175,  170,   93,  481,  172,   91,
       93,   93,  357,   93,   42,   93,  191,   41,  220,  174,
       42,  192,  117,  195,  186,  116,  116,  116,  116,  116,
      116,  119,  175,  193,  130,  201,  130,  196,  119,  119,

      119,  119,  119,  119,   50,  191,  130,  130,  213,   93,
      192,  130,  195,  186,  197,  217,  215,  154,   50,  204,
      194,  193,   41,  130,  201,  196,  205,  119,  119,  119,
      119,  119,  119,   49,   49,   49,  120,  199,  206,  154,
       91,  212,  197,  208,  122,  154,  207,  130,  204,  154,
      209,  271,  123,  130,  205,   93,  356,  154,   91,  123,
      123,  123,  123,  123,  123,  199,  206,   91,   42,  154,
      154,  208,  481,   91,   91,  207,  213,  355,  354,  209,
       93,   93,   41,  353,  247,  124,  231,  154,  123,  123,
      123,  123,  123,  123,  100,  154,  219,  227,   93,  232,

      234,  100,  100,  100,  100,  100,  100,   93,  213,  130,
      237,  238,  130,   93,   93,  231,  279,  285,  154,  154,
      241,  285,  130,   50,  219,  227,  235,  232,  239,  234,
      100,  100,  100,  100,  100,  100,  149,  257,  237,  238,
      154,  240,  154,  149,  149,  149,  149,  149,  149,  241,
      117,  154,  267,  268,  272,  235,  239,   91,  288,  154,
      213,  285,  242,  154,  371,  257,  130,  286,  316,  154,
      240,  296,  149,  149,  149,  149,  149,  149,  162,  264,
      267,  268,  272,  273,  154,  162,  162,  162,  162,  162,
      162,  242,  250,  250,  250,  250,  250,   93,  252,  296,

      154,  285,  403,  253,  285,  254,   92,  286,  264,  154,
      335,  285,  273,  270,  162,  162,  162,  162,  162,  162,
      164,  154,  309,  320,  319,  274,  308,  164,  164,  164,
      164,  164,  164,  154,  250,  250,  250,  250,  250,  335,
      252,  270,  288,  154,  255,  253,  346,  254,  154,  306,
      286,  309,  288,  274,   92,  308,  164,  164,  164,  164,
      164,  164,   99,   99,   99,   99,   99,  154,  114,  318,
      114,  311,  154,  310,   91,  346,  343,  347,  306,  213,
      154,  171,  154,  154,  367,  369,  255,  352,  171,  171,
      171,  171,  171,  171,  283,  283,  283,  283,  283,  311,

      481,  310,  317,  154,  343,  481,  347,  254,  179,  222,
      179,  222,  367,  369,   93,  154,  379,  171,  171,  171,
      171,  171,  171,  110,  177,  177,  177,  110,  282,   41,
      283,  283,  283,  283,  283,  321,  321,  321,  321,  321,
      481,  447,  178,  254,  379,  285,  255,  373,  322,  178,
      178,  178,  178,  178,  178,  283,  283,  283,  283,  283,
      345,  321,  321,  321,  321,  321,  154,  154,  254,  281,
      447,  154,  280,  154,  322,   42,  373,  374,  178,  178,
      178,  178,  178,  178,   40,   40,   40,  109,  345,  130,
      111,  286,  130,  229,   92,  283,  283,  283,  283,  283,

      481,  154,  446,  112,  380,  285,  374,  255,  254,  154,
      112,  112,  112,  112,  112,  112,  283,  283,  283,  283,
      283,  283,  283,  283,  283,  283,  481,  249,  481,  254,
      446,  285,  248,  380,  254,  154,  113,  399,  285,  112,
      112,  112,  112,  112,  112,  180,  406,  255,  154,  130,
      130,  286,  180,  180,  180,  180,  180,  180,  358,  321,
      321,  321,  358,  154,  285,  481,  399,  245,  255,  245,
      481,  359,  471,  255,  406,  285,  130,  286,  117,  288,
      285,  180,  180,  180,  180,  180,  180,  182,  130,  362,
      321,  321,  321,  362,  182,  182,  182,  182,  182,  182,

      285,  130,  363,   99,   99,   99,   99,   99,  154,  229,
      286,  110,  177,  177,  177,  110,  288,   41,  117,   92,
      387,  288,  216,  182,  182,  182,  182,  182,  182,  118,
      118,  118,  118,  118,  163,  163,  163,  163,  163,  165,
      388,  288,  154,  121,  184,  184,  184,  121,  183,  387,
       92,  154,  154,   92,   41,  183,  183,  183,  183,  183,
      183,  200,  154,   42,  181,  181,  181,  181,  181,  388,
      161,  161,  161,  161,  161,  189,  189,  189,  189,  189,
      393,  259,  130,  259,  183,  183,  183,  183,  183,  183,
      121,  184,  184,  184,  121,   50,  277,  298,  277,  298,

      130,   41,  453,  202,  202,  202,  202,  202,  393,  185,
      394,  395,  396,  130,  154,  407,  185,  185,  185,  185,
      185,  185,  154,  358,  321,  321,  321,  358,  408,  285,
      453,  397,  154,  154,  154,  130,  359,  154,  154,  394,
      395,  396,   50,  154,  407,  185,  185,  185,  185,  185,
      185,   49,   49,   49,  120,  154,  408,  409,  418,  397,
      434,  398,  122,  362,  321,  321,  321,  362,  404,  154,
      123,  405,  154,  154,  285,  286,  363,  123,  123,  123,
      123,  123,  123,  154,  130,  409,  418,  419,  434,  314,
      398,  314,  154,  350,  130,  350,  420,  404,  410,  375,

      405,  375,  130,  124,  411,  154,  123,  123,  123,  123,
      123,  123,  190,  154,  130,  288,  419,  154,  130,  190,
      190,  190,  190,  190,  190,  420,  410,  289,  289,  289,
      289,  289,  411,  389,  470,  389,  154,  130,  435,  422,
      254,  423,  421,  414,  414,  414,  414,  414,  190,  190,
      190,  190,  190,  190,  148,  148,  148,  148,  148,  415,
      154,  154,  470,  154,  154,  433,  424,  435,  422,  425,
      423,  421,  154,  198,  437,  438,  436,  130,  154,  255,
      198,  198,  198,  198,  198,  198,  130,  154,  329,  364,
      364,  364,  329,  433,  424,  417,  154,  128,  425,  285,

      154,  154,  117,  437,  438,  436,  130,  117,  432,  198,
      198,  198,  198,  198,  198,  203,  154,  414,  414,  414,
      414,  414,  203,  203,  203,  203,  203,  203,  324,  360,
      360,  360,  324,  415,  285,  169,  432,  165,  154,  151,
      288,  443,  130,  130,   59,  444,  481,  481,  481,  481,
      481,  203,  203,  203,  203,  203,  203,  161,  161,  161,
      161,  161,  481,  154,  426,  426,  426,  426,  426,  417,
      443,  154,  445,  452,  444,  457,  210,  427,   79,  154,
      286,   61,  154,  210,  210,  210,  210,  210,  210,  426,
      426,  426,  426,  426,  128,  125,  451,  154,  417,  117,

      445,  452,  427,  103,  457,  458,  460,  102,  454,  154,
      154,  475,  210,  210,  210,  210,  210,  210,  163,  163,
      163,  163,  163,  154,  451,  101,  154,  154,  154,  426,
      426,  426,  426,  426,  458,  460,  454,  211,  474,  475,
      476,  429,  427,  477,  211,  211,  211,  211,  211,  211,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,
       81,  154,  154,  427,   60,  154,   59,  474,  427,  476,
      463,  459,  477,  211,  211,  211,  211,  211,  211,  218,
      154,  429,   51,   48,  478,  481,  218,  218,  218,  218,
      218,  218,  426,  426,  426,  426,  426,  481,  464,  459,

      465,  469,  429,  466,  481,  427,  154,  429,  154,  154,
      154,  154,  481,  478,  481,  218,  218,  218,  218,  218,
      218,  110,  177,  177,  177,  110,  464,   41,  465,  469,
      481,  466,  426,  426,  426,  426,  426,  473,  481,  481,
      221,  481,  481,  154,  429,  427,  481,  221,  221,  221,
      221,  221,  221,  441,  441,  441,  441,  441,  448,  448,
      448,  448,  448,  481,  481,  473,  427,  480,  479,  481,
      481,  427,  481,   42,  481,  154,  221,  221,  221,  221,
      221,  221,  223,  154,  429,  481,  481,  481,  481,  223,
      223,  223,  223,  223,  223,  480,  479,  481,  481,  481,

      481,  481,  481,  481,  481,  429,  481,  481,  481,  481,
      429,  481,  481,  481,  481,  481,  481,  481,  223,  223,
      223,  223,  223,  223,  181,  181,  181,  181,  181,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  224,  481,  481,  481,  481,  481,  481,
      224,  224,  224,  224,  224,  224,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  224,
      224,  224,  224,  224,  224,  118,  118,  118,  118,  118,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  481,  481,  225,  481,  481,  481,  481,  481,
      481,  225,  225,  225,  225,  225,  225,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      225,  225,  225,  225,  225,  225,  121,  184,  184,  184,
      121,  481,  481,  481,  481,  481,  481,   41,  481,  481,
      481,  481,  481,  481,  481,  226,  481,  481,  481,  481,
      481,  481,  226,  226,  226,  226,  226,  226,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,   50,  481,

      481,  226,  226,  226,  226,  226,  226,  189,  189,  189,
      189,  189,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  230,  481,  481,  481,
      481,  481,  481,  230,  230,  230,  230,  230,  230,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  230,  230,  230,  230,  230,  230,  233,  481,
      481,  481,  481,  481,  481,  233,  233,  233,  233,  233,
      233,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  481,  481,  233,  233,  233,  233,  233,  233,
      202,  202,  202,  202,  202,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  236,
      481,  481,  481,  481,  481,  481,  236,  236,  236,  236,
      236,  236,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  236,  236,  236,  236,  236,
      236,  243,  481,  481,  481,  481,  481,  481,  243,  243,
      243,  243,  243,  243,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  481,  481,  481,  481,  481,  243,  243,  243,
      243,  243,  243,  163,  163,  163,  163,  163,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  244,  481,  481,  481,  481,  481,  481,  244,
      244,  244,  244,  244,  244,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  244,  244,
      244,  244,  244,  244,  256,  481,  481,  481,  481,  481,
      481,  256,  256,  256,  256,  256,  256,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      256,  256,  256,  256,  256,  256,  110,  177,  177,  177,
      110,  481,   41,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  258,  481,  481,  481,  481,
      481,  481,  258,  258,  258,  258,  258,  258,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,   42,  481,
      481,  258,  258,  258,  258,  258,  258,  260,  481,  481,
      481,  481,  481,  481,  260,  260,  260,  260,  260,  260,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  260,  260,  260,  260,  260,  260,  181,
      181,  181,  181,  181,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  261,  481,
      481,  481,  481,  481,  481,  261,  261,  261,  261,  261,
      261,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  261,  261,  261,  261,  261,  261,
      118,  118,  118,  118,  118,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  262,

      481,  481,  481,  481,  481,  481,  262,  262,  262,  262,
      262,  262,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  262,  262,  262,  262,  262,
      262,  121,  184,  184,  184,  121,  481,  481,  481,  481,
      481,  481,   41,  481,  481,  481,  481,  481,  481,  481,
      263,  481,  481,  481,  481,  481,  481,  263,  263,  263,
      263,  263,  263,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,   50,  481,  481,  263,  263,  263,  263,

      263,  263,  189,  189,  189,  189,  189,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  265,  481,  481,  481,  481,  481,  481,  265,  265,
      265,  265,  265,  265,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  265,  265,  265,
      265,  265,  265,  266,  481,  481,  481,  481,  481,  481,
      266,  266,  266,  266,  266,  266,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  266,

      266,  266,  266,  266,  266,  202,  202,  202,  202,  202,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  269,  481,  481,  481,  481,  481,
      481,  269,  269,  269,  269,  269,  269,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      269,  269,  269,  269,  269,  269,  275,  481,  481,  481,
      481,  481,  481,  275,  275,  275,  275,  275,  275,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  275,  275,  275,  275,  275,  275,  163,  163,
      163,  163,  163,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  276,  481,  481,
      481,  481,  481,  481,  276,  276,  276,  276,  276,  276,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  276,  276,  276,  276,  276,  276,  283,
      283,  283,  283,  289,  481,  291,  481,  481,  481,  481,
      291,  291,  292,  481,  481,  481,  481,  481,  293,  481,
      481,  481,  481,  481,  481,  293,  293,  293,  293,  293,

      293,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  294,  481,  481,  293,  293,  293,  293,  293,  293,
      295,  481,  481,  481,  481,  481,  481,  295,  295,  295,
      295,  295,  295,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  295,  295,  295,  295,
      295,  295,  110,  177,  177,  177,  110,  481,   41,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  297,  481,  481,  481,  481,  481,  481,  297,  297,

      297,  297,  297,  297,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,   42,  481,  481,  297,  297,  297,
      297,  297,  297,  299,  481,  481,  481,  481,  481,  481,
      299,  299,  299,  299,  299,  299,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  117,  481,  481,  299,
      299,  299,  299,  299,  299,  181,  181,  181,  181,  181,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  300,  481,  481,  481,  481,  481,

      481,  300,  300,  300,  300,  300,  300,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  117,  481,  481,
      300,  300,  300,  300,  300,  300,  118,  118,  118,  118,
      118,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  301,  481,  481,  481,  481,
      481,  481,  301,  301,  301,  301,  301,  301,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  301,  301,  301,  301,  301,  301,  121,  184,  184,

      184,  121,  481,  481,  481,  481,  481,  481,   41,  481,
      481,  481,  481,  481,  481,  481,  302,  481,  481,  481,
      481,  481,  481,  302,  302,  302,  302,  302,  302,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,   50,
      481,  481,  302,  302,  302,  302,  302,  302,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,   92,  481,  481,
      481,  481,  481,  481,   92,   92,   92,   92,   92,   92,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  481,  303,  481,  481,  481,  481,  481,  481,
      481,  481,  481,   92,   92,   92,   92,   92,   92,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  303,  189,  189,  189,  189,  189,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  304,  481,  481,  481,  481,  481,  481,  304,  304,
      304,  304,  304,  304,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  304,  304,  304,
      304,  304,  304,  305,  481,  481,  481,  481,  481,  481,

      305,  305,  305,  305,  305,  305,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  305,
      305,  305,  305,  305,  305,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  129,  481,  481,  481,  481,  481,
      481,  129,  129,  129,  129,  129,  129,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      129,  129,  129,  129,  129,  129,  202,  202,  202,  202,

      202,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  307,  481,  481,  481,  481,
      481,  481,  307,  307,  307,  307,  307,  307,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  307,  307,  307,  307,  307,  307,  312,  481,  481,
      481,  481,  481,  481,  312,  312,  312,  312,  312,  312,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  312,  312,  312,  312,  312,  312,  163,

      163,  163,  163,  163,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  313,  481,
      481,  481,  481,  481,  481,  313,  313,  313,  313,  313,
      313,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  313,  313,  313,  313,  313,  313,
      284,  284,  284,  323,  481,  481,  325,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  326,
      481,  481,  481,  481,  481,  481,  326,  326,  326,  326,
      326,  326,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  327,  481,  481,  326,  326,  326,  326,  326,
      326,  287,  287,  287,  328,  481,  481,  481,  481,  481,
      481,  481,  330,  481,  481,  481,  481,  481,  481,  481,
      331,  481,  481,  481,  481,  481,  481,  331,  331,  331,
      331,  331,  331,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  332,  481,  481,  331,  331,  331,  331,
      331,  331,  289,  289,  289,  289,  289,  481,  481,  481,
      481,  481,  481,  481,  481,  254,  481,  481,  481,  481,

      481,  333,  481,  481,  481,  481,  481,  481,  333,  333,
      333,  333,  333,  333,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  255,  481,  481,  333,  333,  333,
      333,  333,  333,  283,  283,  283,  283,  289,  481,  291,
      481,  481,  481,  481,  291,  291,  292,  481,  481,  481,
      481,  481,  293,  481,  481,  481,  481,  481,  481,  293,
      293,  293,  293,  293,  293,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  294,  481,  481,  293,  293,

      293,  293,  293,  293,  334,  481,  481,  481,  481,  481,
      481,  334,  334,  334,  334,  334,  334,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      334,  334,  334,  334,  334,  334,  110,  177,  177,  177,
      110,  481,   41,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  336,  481,  481,  481,  481,
      481,  481,  336,  336,  336,  336,  336,  336,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,   42,  481,

      481,  336,  336,  336,  336,  336,  336,  181,  181,  181,
      181,  181,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  337,  481,  481,  481,
      481,  481,  481,  337,  337,  337,  337,  337,  337,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  117,
      481,  481,  337,  337,  337,  337,  337,  337,  118,  118,
      118,  118,  118,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  338,  481,  481,
      481,  481,  481,  481,  338,  338,  338,  338,  338,  338,

      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  338,  338,  338,  338,  338,  338,  121,
      184,  184,  184,  121,  481,  481,  481,  481,  481,  481,
       41,  481,  481,  481,  481,  481,  481,  481,  339,  481,
      481,  481,  481,  481,  481,  339,  339,  339,  339,  339,
      339,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,   50,  481,  481,  339,  339,  339,  339,  339,  339,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  481,  481,  481,  481,  340,  481,  481,   92,
      481,  481,  481,  481,  481,  481,   92,   92,   92,   92,
       92,   92,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,   92,   92,   92,   92,   92,
       92,  189,  189,  189,  189,  189,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      341,  481,  481,  481,  481,  481,  481,  341,  341,  341,
      341,  341,  341,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  481,  481,  481,  481,  341,  341,  341,  341,
      341,  341,  148,  148,  148,  148,  148,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  342,  481,  481,  481,  481,  481,  481,  342,  342,
      342,  342,  342,  342,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  342,  342,  342,
      342,  342,  342,  202,  202,  202,  202,  202,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  344,  481,  481,  481,  481,  481,  481,  344,

      344,  344,  344,  344,  344,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  344,  344,
      344,  344,  344,  344,  348,  481,  481,  481,  481,  481,
      481,  348,  348,  348,  348,  348,  348,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      348,  348,  348,  348,  348,  348,  163,  163,  163,  163,
      163,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  349,  481,  481,  481,  481,

      481,  481,  349,  349,  349,  349,  349,  349,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  349,  349,  349,  349,  349,  349,  324,  360,  360,
      360,  324,  481,  285,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  361,  481,  481,  481,
      481,  481,  481,  361,  361,  361,  361,  361,  361,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  286,
      481,  481,  361,  361,  361,  361,  361,  361,  284,  284,

      284,  323,  481,  481,  325,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  326,  481,  481,
      481,  481,  481,  481,  326,  326,  326,  326,  326,  326,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      327,  481,  481,  326,  326,  326,  326,  326,  326,  329,
      364,  364,  364,  329,  481,  481,  481,  481,  481,  481,
      285,  481,  481,  481,  481,  481,  481,  481,  365,  481,
      481,  481,  481,  481,  481,  365,  365,  365,  365,  365,
      365,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  288,  481,  481,  365,  365,  365,  365,  365,  365,
      287,  287,  287,  328,  481,  481,  481,  481,  481,  481,
      481,  330,  481,  481,  481,  481,  481,  481,  481,  331,
      481,  481,  481,  481,  481,  481,  331,  331,  331,  331,
      331,  331,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  332,  481,  481,  331,  331,  331,  331,  331,
      331,  289,  289,  289,  289,  289,  481,  481,  481,  481,
      481,  481,  481,  481,  254,  481,  481,  481,  481,  481,

      366,  481,  481,  481,  481,  481,  481,  366,  366,  366,
      366,  366,  366,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  255,  481,  481,  366,  366,  366,  366,
      366,  366,  368,  481,  481,  481,  481,  481,  481,  368,
      368,  368,  368,  368,  368,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  368,  368,
      368,  368,  368,  368,  115,  481,  481,  481,  481,  481,
      481,  115,  115,  115,  115,  115,  115,  481,  481,  481,

      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      115,  115,  115,  115,  115,  115,  370,  481,  481,  481,
      481,  481,  481,  370,  370,  370,  370,  370,  370,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  370,  370,  370,  370,  370,  370,  148,  148,
      148,  148,  148,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  129,  481,  481,
      481,  481,  481,  481,  129,  129,  129,  129,  129,  129,

      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  129,  129,  129,  129,  129,  129,  202,
      202,  202,  202,  202,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  372,  481,
      481,  481,  481,  481,  481,  372,  372,  372,  372,  372,
      372,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  372,  372,  372,  372,  372,  372,
      376,  481,  481,  481,  481,  481,  481,  376,  376,  376,

      376,  376,  376,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  376,  376,  376,  376,
      376,  376,  377,  481,  481,  481,  481,  481,  481,  377,
      377,  377,  377,  377,  377,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  377,  377,
      377,  377,  377,  377,  289,  289,  289,  289,  289,  481,
      481,  481,  481,  481,  481,  481,  481,  254,  481,  481,
      481,  481,  481,  378,  481,  481,  481,  481,  481,  481,

      378,  378,  378,  378,  378,  378,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  255,  481,  481,  378,
      378,  378,  378,  378,  378,  381,  481,  481,  481,  481,
      481,  481,  382,  481,  383,  481,  481,  481,  481,  384,
      385,  481,  481,  386,  481,  481,  481,  481,  154,  481,
      481,  481,  481,  481,  381,  481,  481,  481,  481,  481,
      382,  481,  383,  481,  481,  481,  481,  384,  385,  481,
      481,  386,  390,  481,  481,  481,  481,  481,  481,  390,
      390,  390,  390,  390,  390,  481,  481,  481,  481,  481,

      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  390,  390,
      390,  390,  390,  390,  391,  481,  481,  481,  481,  481,
      481,  391,  391,  391,  391,  391,  391,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      391,  391,  391,  391,  391,  391,  392,  481,  481,  481,
      481,  481,  481,  392,  392,  392,  392,  392,  392,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  392,  392,  392,  392,  392,  392,  400,  481,
      481,  481,  481,  481,  481,  400,  400,  400,  400,  400,
      400,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  400,  400,  400,  400,  400,  400,
      401,  481,  481,  481,  481,  481,  481,  401,  401,  401,
      401,  401,  401,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  401,  401,  401,  401,
      401,  401,  402,  481,  481,  481,  481,  481,  481,  402,

      402,  402,  402,  402,  402,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  402,  402,
      402,  402,  402,  402,  412,  481,  481,  481,  481,  481,
      481,  412,  412,  412,  412,  412,  412,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      412,  412,  412,  412,  412,  412,  413,  481,  481,  481,
      481,  481,  481,  413,  413,  413,  413,  413,  413,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  413,  413,  413,  413,  413,  413,  431,  481,
      481,  481,  481,  481,  481,  431,  431,  431,  431,  431,
      431,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  431,  431,  431,  431,  431,  431,
      440,  481,  481,  481,  481,  481,  481,  440,  440,  440,
      440,  440,  440,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  440,  440,  440,  440,

      440,  440,  441,  441,  441,  441,  441,  481,  481,  481,
      481,  481,  481,  481,  481,  427,  481,  481,  481,  481,
      481,  442,  481,  481,  481,  481,  481,  481,  442,  442,
      442,  442,  442,  442,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  429,  481,  481,  442,  442,  442,
      442,  442,  442,  448,  448,  448,  448,  448,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  449,  481,  481,  481,  481,  481,  481,  449,
      449,  449,  449,  449,  449,  481,  481,  481,  481,  481,

      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  449,  449,
      449,  449,  449,  449,  450,  481,  481,  481,  481,  481,
      481,  450,  450,  450,  450,  450,  450,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      450,  450,  450,  450,  450,  450,  455,  481,  481,  481,
      481,  481,  481,  455,  455,  455,  455,  455,  455,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  455,  455,  455,  455,  455,  455,  456,  481,
      481,  481,  481,  481,  481,  456,  456,  456,  456,  456,
      456,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  456,  456,  456,  456,  456,  456,
      461,  481,  481,  481,  481,  481,  481,  461,  461,  461,
      461,  461,  461,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  461,  461,  461,  461,
      461,  461,  462,  481,  481,  481,  481,  481,  481,  462,

      462,  462,  462,  462,  462,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  462,  462,
      462,  462,  462,  462,  467,  481,  481,  481,  481,  481,
      481,  467,  467,  467,  467,  467,  467,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      467,  467,  467,  467,  467,  467,  468,  481,  481,  481,
      481,  481,  481,  468,  468,  468,  468,  468,  468,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  468,  468,  468,  468,  468,  468,  472,  481,
      481,  481,  481,  481,  481,  472,  472,  472,  472,  472,
      472,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  472,  472,  472,  472,  472,  472,
       40,  481,  481,   40,   40,   40,   40,   40,   40,   40,
       40,   40,   40,   46,   46,  481,   46,   46,   49,  481,
      481,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   55,   55,  481,   55,   55,   83,  481,  481,   83,

       83,   92,  481,   92,   92,  481,   92,   92,   99,   99,
       99,   99,   99,   99,   99,   99,   99,   99,  110,  110,
      110,  110,  110,  110,  110,  110,  110,  110,  110,  110,
      110,  115,  115,  481,  115,  115,  118,  118,  118,  118,
      118,  118,  118,  118,  118,  118,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  127,
      127,  127,  127,  127,  127,  127,  127,  127,  127,  127,
      127,  127,  127,  129,  129,  481,  129,  129,  148,  148,
      148,  148,  148,  148,  148,  148,  148,  148,  153,  153,
      481,  153,  153,  161,  161,  161,  161,  161,  161,  161,

      161,  161,  161,  163,  163,  163,  163,  163,  163,  163,
      163,  163,  163,  168,  168,  168,  181,  181,  181,  181,
      181,  181,  181,  181,  181,  181,   49,   49,  481,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  127,  127,  127,  127,  127,  127,  127,  127,
      127,  127,  127,  127,  127,  127,  187,  187,  187,  187,
      187,  187,  187,  187,  187,  187,  187,  187,  187,  187,
      189,  189,  189,  189,  189,  189,  189,  189,  189,  189,
      202,  202,  202,  202,  202,  202,  202,  202,  202,  202,

      214,  214,  214,  214,   40,  481,  481,   40,   40,   40,
       40,   40,   40,   40,   40,   40,   40,  228,  228,  228,
      228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
      228,  246,  246,  246,  246,  251,  251,  251,  251,  251,
      251,  481,  251,  251,  251,  251,  251,  251,   40,   40,
       40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
       40,  187,  187,  187,  187,  187,  187,  187,  187,  187,
      187,  187,  187,  187,  187,  278,  278,  278,  278,  251,
      251,  251,  251,  251,  251,  481,  251,  251,  251,  251,
      251,  251,  284,  481,  481,  284,  284,  284,  284,  284,

      284,  284,  284,  284,  284,  287,  481,  481,  287,  287,
      287,  287,  287,  287,  287,  287,  287,  287,  290,  290,
      290,  290,  290,  290,  290,  290,  290,  290,  290,  290,
      290,   40,   40,   40,   40,   40,   40,   40,   40,   40,
       40,   40,   40,   40,  115,  115,  481,  115,  115,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,  315,  315,  315,  315,  324,  324,  324,  324,
      324,  324,  324,  324,  324,  324,  324,  324,  324,  287,
      481,  481,  287,  287,  287,  287,  287,  287,  287,  287,
      287,  287,  329,  329,  329,  329,  329,  329,  329,  329,

      329,  329,  329,  329,  329,  251,  251,  251,  251,  251,
      481,  481,  251,  251,  251,  251,  251,  251,  290,  290,
      290,  290,  290,  290,  290,  290,  290,  290,  290,  290,
      290,   40,   40,   40,   40,   40,   40,   40,   40,   40,
       40,   40,   40,   40,  115,  115,  481,  115,  115,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,  351,  351,  351,  351,  284,  284,  481,  284,
      284,  284,  284,  284,  284,  284,  284,  284,  284,  324,
      324,  324,  324,  324,  324,  324,  324,  324,  324,  324,
      324,  324,  287,  287,  481,  287,  287,  287,  287,  287,

      287,  287,  287,  287,  287,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  251,  251,
      251,  251,  251,  481,  481,  251,  251,  251,  251,  251,
      251,  416,  416,  416,  416,  481,  481,  481,  481,  416,
      481,  481,  416,  416,  428,  428,  428,  428,  481,  481,
      481,  428,  428,  428,  481,  428,  428,  430,  430,  430,
      430,  430,  430,  430,  430,  430,  430,  439,  439,  439,
      439,  439,  439,  439,  439,  439,  439,    7,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481
    } ;

static yyconst flex_int16_t yy_chk[6664] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    3,    5,    4,    6,   15,
       12,    3,  480,    4,    9,    9,    9,    9,    9,   10,

       10,   10,   10,   10,    3,    3,    4,    4,   11,   11,
       11,   11,   11,   24,   32,    5,   18,    6,   17,   18,
        3,   25,    4,   33,   25,   25,   33,   33,   39,   49,
       15,  477,    3,    3,    4,    4,   12,   69,   17,   18,
       36,   32,   11,   40,  470,    3,   69,    4,   18,   25,
      464,   33,   18,   24,   32,   55,   39,   43,   52,   26,
       43,   25,   26,   33,   34,   69,   17,   18,   36,   32,
       49,   11,   13,   53,   53,   13,   18,   25,   52,   33,
       36,   67,   13,   13,   13,   13,   13,   13,  459,   40,
       26,   34,   71,   43,   78,   55,   36,   88,  128,   26,

       78,  443,  128,   67,   34,   71,   52,   80,   13,   80,
       67,   13,   13,   13,   13,   13,   13,   21,   26,   34,
       71,   92,   78,   88,   21,   21,   88,   21,   37,   37,
       37,   37,   37,  437,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   92,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   66,   99,
       72,   21,   23,   70,   70,  432,   38,   38,   38,   38,

       38,   59,   66,   59,   23,  422,   89,   23,   56,   72,
       23,   56,   56,   68,   23,   23,   66,   23,   84,   72,
       57,   70,   85,   59,   68,   74,   74,   68,   23,   99,
       38,  120,   89,   23,   85,   89,   23,   84,   57,   23,
       76,   68,   23,   23,   76,   23,   27,   84,   56,  108,
       85,   59,   68,   27,   27,   27,   27,   27,   27,   38,
       57,  229,   74,   82,   73,  229,   76,   57,  388,   76,
       73,   96,  120,   76,  495,  495,   75,  108,   73,   87,
      105,  110,   27,   27,   27,   27,   27,   27,   42,   42,
       42,   42,   73,   75,   42,   82,   86,   75,   73,   82,

       75,   87,   95,  141,   96,   75,  387,   42,   87,   95,
       86,   96,   98,  105,   42,   42,   42,   42,   42,   42,
      105,   75,  104,   82,   86,   75,  106,  110,  111,  109,
      163,  166,   96,  107,  109,  167,  141,   98,  166,  104,
       42,  105,   95,   42,   42,   42,   42,   42,   42,   45,
      176,  106,   98,  121,  351,  345,   45,   45,   45,   45,
       45,   45,  104,  121,  107,   98,  106,  122,  104,  126,
      163,  166,  320,  107,  111,  167,  132,  122,  176,  106,
      109,  135,   45,  145,  126,   45,   45,   45,   45,   45,
       45,   47,  107,  138,  138,  152,  132,  146,   47,   47,

       47,   47,   47,   47,  121,  132,  145,  135,  168,  126,
      135,  146,  145,  126,  147,  170,  168,  152,  122,  155,
      194,  138,  177,  147,  152,  146,  156,   47,   47,   47,
       47,   47,   47,   50,   50,   50,   50,  150,  157,  156,
      172,  173,  147,  159,   50,  155,  158,  150,  155,  157,
      160,  238,   50,  194,  156,  170,  319,  159,  174,   50,
       50,   50,   50,   50,   50,  150,  157,  175,  177,  158,
      160,  159,  184,  186,  219,  158,  214,  318,  317,  160,
      172,  173,  184,  316,  214,   50,  192,  238,   50,   50,
       50,   50,   50,   50,   58,  310,  174,  186,  174,  197,

      199,   58,   58,   58,   58,   58,   58,  175,  246,  192,
      204,  205,  197,  186,  219,  192,  246,  253,  205,  204,
      208,  252,  199,  184,  174,  186,  201,  197,  206,  199,
       58,   58,   58,   58,   58,   58,   79,  220,  204,  205,
      206,  207,  208,   79,   79,   79,   79,   79,   79,  208,
      299,  201,  234,  235,  239,  201,  206,  227,  253,  207,
      278,  284,  209,  239,  343,  220,  234,  252,  278,  235,
      207,  257,   79,   79,   79,   79,   79,   79,   90,  227,
      234,  235,  239,  240,  209,   90,   90,   90,   90,   90,
       90,  209,  217,  217,  217,  217,  217,  227,  217,  257,

      343,  287,  393,  217,  323,  217,  393,  284,  227,  240,
      296,  328,  240,  237,   90,   90,   90,   90,   90,   90,
       93,  237,  271,  282,  281,  241,  270,   93,   93,   93,
       93,   93,   93,  241,  250,  250,  250,  250,  250,  296,
      250,  237,  287,  271,  217,  250,  309,  250,  270,  268,
      323,  271,  328,  241,  340,  270,   93,   93,   93,   93,
       93,   93,  100,  100,  100,  100,  100,  268,  490,  280,
      490,  274,  309,  272,  100,  309,  306,  311,  268,  315,
      272,  100,  274,  306,  335,  340,  250,  315,  100,  100,
      100,  100,  100,  100,  251,  251,  251,  251,  251,  274,

      251,  272,  279,  311,  306,  251,  311,  251,  502,  512,
      502,  512,  335,  340,  100,  273,  367,  100,  100,  100,
      100,  100,  100,  112,  112,  112,  112,  112,  249,  112,
      283,  283,  283,  283,  283,  285,  285,  285,  285,  285,
      324,  438,  112,  283,  367,  324,  251,  346,  285,  112,
      112,  112,  112,  112,  112,  289,  289,  289,  289,  289,
      308,  321,  321,  321,  321,  321,  438,  308,  289,  248,
      438,  346,  247,  242,  321,  112,  346,  347,  112,  112,
      112,  112,  112,  112,  113,  113,  113,  113,  308,  232,
      113,  324,  231,  228,  369,  290,  290,  290,  290,  290,

      359,  347,  436,  113,  369,  359,  347,  289,  290,  436,
      113,  113,  113,  113,  113,  113,  291,  291,  291,  291,
      291,  292,  292,  292,  292,  292,  360,  216,  329,  291,
      436,  360,  215,  369,  292,  202,  113,  386,  329,  113,
      113,  113,  113,  113,  113,  116,  395,  290,  395,  196,
      195,  359,  116,  116,  116,  116,  116,  116,  325,  325,
      325,  325,  325,  386,  325,  363,  386,  514,  291,  514,
      364,  325,  466,  292,  395,  363,  193,  360,  116,  329,
      364,  116,  116,  116,  116,  116,  116,  117,  191,  330,
      330,  330,  330,  330,  117,  117,  117,  117,  117,  117,

      330,  189,  330,  334,  334,  334,  334,  334,  466,  187,
      325,  336,  336,  336,  336,  336,  363,  336,  181,  334,
      373,  364,  169,  117,  117,  117,  117,  117,  117,  119,
      119,  119,  119,  119,  349,  349,  349,  349,  349,  165,
      374,  330,  373,  339,  339,  339,  339,  339,  119,  373,
      349,  161,  153,  380,  339,  119,  119,  119,  119,  119,
      119,  151,  374,  336,  368,  368,  368,  368,  368,  374,
      348,  348,  348,  348,  348,  370,  370,  370,  370,  370,
      380,  518,  148,  518,  119,  119,  119,  119,  119,  119,
      123,  123,  123,  123,  123,  339,  520,  527,  520,  527,

      144,  123,  446,  372,  372,  372,  372,  372,  380,  123,
      381,  382,  383,  143,  446,  396,  123,  123,  123,  123,
      123,  123,  348,  358,  358,  358,  358,  358,  397,  358,
      446,  384,  381,  382,  383,  142,  358,  384,  396,  381,
      382,  383,  123,  397,  396,  123,  123,  123,  123,  123,
      123,  124,  124,  124,  124,  372,  397,  398,  404,  384,
      420,  385,  124,  362,  362,  362,  362,  362,  394,  420,
      124,  394,  398,  404,  362,  358,  362,  124,  124,  124,
      124,  124,  124,  385,  140,  398,  404,  405,  420,  530,
      385,  530,  394,  540,  139,  540,  406,  394,  399,  547,

      394,  547,  137,  124,  399,  405,  124,  124,  124,  124,
      124,  124,  130,  399,  136,  362,  405,  406,  134,  130,
      130,  130,  130,  130,  130,  406,  399,  402,  402,  402,
      402,  402,  399,  548,  465,  548,  465,  133,  421,  408,
      402,  409,  407,  403,  403,  403,  403,  403,  130,  130,
      130,  130,  130,  130,  149,  149,  149,  149,  149,  403,
      407,  408,  465,  409,  421,  419,  410,  421,  408,  411,
      409,  407,  410,  149,  424,  425,  423,  131,  419,  402,
      149,  149,  149,  149,  149,  149,  129,  411,  413,  413,
      413,  413,  413,  419,  410,  403,  424,  127,  411,  413,

      423,  425,  118,  424,  425,  423,  149,  115,  418,  149,
      149,  149,  149,  149,  149,  154,  418,  414,  414,  414,
      414,  414,  154,  154,  154,  154,  154,  154,  412,  412,
      412,  412,  412,  414,  412,   97,  418,   94,   83,   81,
      413,  433,   77,   65,   63,  434,  415,  415,  415,  415,
      415,  154,  154,  154,  154,  154,  154,  162,  162,  162,
      162,  162,  415,  433,  426,  426,  426,  426,  426,  414,
      433,  434,  435,  445,  434,  451,  162,  426,   62,  445,
      412,   61,  435,  162,  162,  162,  162,  162,  162,  416,
      416,  416,  416,  416,   60,   54,  444,  451,  415,   46,

      435,  445,  416,   30,  451,  452,  454,   29,  447,  162,
      444,  473,  162,  162,  162,  162,  162,  162,  164,  164,
      164,  164,  164,  447,  444,   28,  473,  452,  454,  428,
      428,  428,  428,  428,  452,  454,  447,  164,  471,  473,
      474,  416,  428,  475,  164,  164,  164,  164,  164,  164,
      430,  430,  430,  430,  430,  439,  439,  439,  439,  439,
       22,  471,  474,  430,   20,  475,   19,  471,  439,  474,
      457,  453,  475,  164,  164,  164,  164,  164,  164,  171,
      453,  428,   16,   14,  476,    7,  171,  171,  171,  171,
      171,  171,  441,  441,  441,  441,  441,    0,  457,  453,

      458,  463,  430,  460,    0,  441,  457,  439,  476,  458,
      463,  460,    0,  476,    0,  171,  171,  171,  171,  171,
      171,  178,  178,  178,  178,  178,  457,  178,  458,  463,
        0,  460,  448,  448,  448,  448,  448,  469,    0,    0,
      178,    0,    0,  469,  441,  448,    0,  178,  178,  178,
      178,  178,  178,  468,  468,  468,  468,  468,  472,  472,
      472,  472,  472,    0,    0,  469,  468,  479,  478,    0,
        0,  472,    0,  178,    0,  479,  178,  178,  178,  178,
      178,  178,  180,  478,  448,    0,    0,    0,    0,  180,
      180,  180,  180,  180,  180,  479,  478,    0,    0,    0,

        0,    0,    0,    0,    0,  468,    0,    0,    0,    0,
      472,    0,    0,    0,    0,    0,    0,    0,  180,  180,
      180,  180,  180,  180,  182,  182,  182,  182,  182,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  182,    0,    0,    0,    0,    0,    0,
      182,  182,  182,  182,  182,  182,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,  182,
      182,  182,  182,  182,  182,  183,  183,  183,  183,  183,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,  183,    0,    0,    0,    0,    0,
        0,  183,  183,  183,  183,  183,  183,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      183,  183,  183,  183,  183,  183,  185,  185,  185,  185,
      185,    0,    0,    0,    0,    0,    0,  185,    0,    0,
        0,    0,    0,    0,    0,  185,    0,    0,    0,    0,
        0,    0,  185,  185,  185,  185,  185,  185,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  185,    0,

        0,  185,  185,  185,  185,  185,  185,  190,  190,  190,
      190,  190,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,  190,    0,    0,    0,
        0,    0,    0,  190,  190,  190,  190,  190,  190,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,  190,  190,  190,  190,  190,  190,  198,    0,
        0,    0,    0,    0,    0,  198,  198,  198,  198,  198,
      198,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,  198,  198,  198,  198,  198,  198,
      203,  203,  203,  203,  203,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,  203,
        0,    0,    0,    0,    0,    0,  203,  203,  203,  203,
      203,  203,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,  203,  203,  203,  203,  203,
      203,  210,    0,    0,    0,    0,    0,    0,  210,  210,
      210,  210,  210,  210,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,  210,  210,  210,
      210,  210,  210,  211,  211,  211,  211,  211,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,  211,    0,    0,    0,    0,    0,    0,  211,
      211,  211,  211,  211,  211,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  211,  211,
      211,  211,  211,  211,  218,    0,    0,    0,    0,    0,
        0,  218,  218,  218,  218,  218,  218,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      218,  218,  218,  218,  218,  218,  221,  221,  221,  221,
      221,    0,  221,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,  221,    0,    0,    0,    0,
        0,    0,  221,  221,  221,  221,  221,  221,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  221,    0,
        0,  221,  221,  221,  221,  221,  221,  223,    0,    0,
        0,    0,    0,    0,  223,  223,  223,  223,  223,  223,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  223,  223,  223,  223,  223,  223,  224,
      224,  224,  224,  224,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  224,    0,
        0,    0,    0,    0,    0,  224,  224,  224,  224,  224,
      224,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  224,  224,  224,  224,  224,  224,
      225,  225,  225,  225,  225,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,  225,

        0,    0,    0,    0,    0,    0,  225,  225,  225,  225,
      225,  225,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,  225,  225,  225,  225,  225,
      225,  226,  226,  226,  226,  226,    0,    0,    0,    0,
        0,    0,  226,    0,    0,    0,    0,    0,    0,    0,
      226,    0,    0,    0,    0,    0,    0,  226,  226,  226,
      226,  226,  226,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  226,    0,    0,  226,  226,  226,  226,

      226,  226,  230,  230,  230,  230,  230,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,  230,    0,    0,    0,    0,    0,    0,  230,  230,
      230,  230,  230,  230,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,  230,  230,  230,
      230,  230,  230,  233,    0,    0,    0,    0,    0,    0,
      233,  233,  233,  233,  233,  233,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,  233,

      233,  233,  233,  233,  233,  236,  236,  236,  236,  236,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  236,    0,    0,    0,    0,    0,
        0,  236,  236,  236,  236,  236,  236,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      236,  236,  236,  236,  236,  236,  243,    0,    0,    0,
        0,    0,    0,  243,  243,  243,  243,  243,  243,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,  243,  243,  243,  243,  243,  243,  244,  244,
      244,  244,  244,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,  244,    0,    0,
        0,    0,    0,    0,  244,  244,  244,  244,  244,  244,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  244,  244,  244,  244,  244,  244,  255,
      255,  255,  255,  255,    0,  255,    0,    0,    0,    0,
      255,  255,  255,    0,    0,    0,    0,    0,  255,    0,
        0,    0,    0,    0,    0,  255,  255,  255,  255,  255,

      255,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,  255,    0,    0,  255,  255,  255,  255,  255,  255,
      256,    0,    0,    0,    0,    0,    0,  256,  256,  256,
      256,  256,  256,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,  256,  256,  256,  256,
      256,  256,  258,  258,  258,  258,  258,    0,  258,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,  258,    0,    0,    0,    0,    0,    0,  258,  258,

      258,  258,  258,  258,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  258,    0,    0,  258,  258,  258,
      258,  258,  258,  260,    0,    0,    0,    0,    0,    0,
      260,  260,  260,  260,  260,  260,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,  260,    0,    0,  260,
      260,  260,  260,  260,  260,  261,  261,  261,  261,  261,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  261,    0,    0,    0,    0,    0,

        0,  261,  261,  261,  261,  261,  261,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,  261,    0,    0,
      261,  261,  261,  261,  261,  261,  262,  262,  262,  262,
      262,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,  262,    0,    0,    0,    0,
        0,    0,  262,  262,  262,  262,  262,  262,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,  262,  262,  262,  262,  262,  262,  263,  263,  263,

      263,  263,    0,    0,    0,    0,    0,    0,  263,    0,
        0,    0,    0,    0,    0,    0,  263,    0,    0,    0,
        0,    0,    0,  263,  263,  263,  263,  263,  263,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,  263,
        0,    0,  263,  263,  263,  263,  263,  263,  264,  264,
      264,  264,  264,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,  264,    0,    0,
        0,    0,    0,    0,  264,  264,  264,  264,  264,  264,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,  264,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  264,  264,  264,  264,  264,  264,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,  264,  265,  265,  265,  265,  265,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,  265,    0,    0,    0,    0,    0,    0,  265,  265,
      265,  265,  265,  265,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,  265,  265,  265,
      265,  265,  265,  266,    0,    0,    0,    0,    0,    0,

      266,  266,  266,  266,  266,  266,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,  266,
      266,  266,  266,  266,  266,  267,  267,  267,  267,  267,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  267,    0,    0,    0,    0,    0,
        0,  267,  267,  267,  267,  267,  267,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      267,  267,  267,  267,  267,  267,  269,  269,  269,  269,

      269,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,  269,    0,    0,    0,    0,
        0,    0,  269,  269,  269,  269,  269,  269,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,  269,  269,  269,  269,  269,  269,  275,    0,    0,
        0,    0,    0,    0,  275,  275,  275,  275,  275,  275,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  275,  275,  275,  275,  275,  275,  276,

      276,  276,  276,  276,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  276,    0,
        0,    0,    0,    0,    0,  276,  276,  276,  276,  276,
      276,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  276,  276,  276,  276,  276,  276,
      286,  286,  286,  286,    0,    0,  286,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,  286,
        0,    0,    0,    0,    0,    0,  286,  286,  286,  286,
      286,  286,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,  286,    0,    0,  286,  286,  286,  286,  286,
      286,  288,  288,  288,  288,    0,    0,    0,    0,    0,
        0,    0,  288,    0,    0,    0,    0,    0,    0,    0,
      288,    0,    0,    0,    0,    0,    0,  288,  288,  288,
      288,  288,  288,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  288,    0,    0,  288,  288,  288,  288,
      288,  288,  293,  293,  293,  293,  293,    0,    0,    0,
        0,    0,    0,    0,    0,  293,    0,    0,    0,    0,

        0,  293,    0,    0,    0,    0,    0,    0,  293,  293,
      293,  293,  293,  293,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  293,    0,    0,  293,  293,  293,
      293,  293,  293,  294,  294,  294,  294,  294,    0,  294,
        0,    0,    0,    0,  294,  294,  294,    0,    0,    0,
        0,    0,  294,    0,    0,    0,    0,    0,    0,  294,
      294,  294,  294,  294,  294,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,  294,    0,    0,  294,  294,

      294,  294,  294,  294,  295,    0,    0,    0,    0,    0,
        0,  295,  295,  295,  295,  295,  295,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      295,  295,  295,  295,  295,  295,  297,  297,  297,  297,
      297,    0,  297,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,  297,    0,    0,    0,    0,
        0,    0,  297,  297,  297,  297,  297,  297,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  297,    0,

        0,  297,  297,  297,  297,  297,  297,  300,  300,  300,
      300,  300,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,  300,    0,    0,    0,
        0,    0,    0,  300,  300,  300,  300,  300,  300,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,  300,
        0,    0,  300,  300,  300,  300,  300,  300,  301,  301,
      301,  301,  301,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,  301,    0,    0,
        0,    0,    0,    0,  301,  301,  301,  301,  301,  301,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  301,  301,  301,  301,  301,  301,  302,
      302,  302,  302,  302,    0,    0,    0,    0,    0,    0,
      302,    0,    0,    0,    0,    0,    0,    0,  302,    0,
        0,    0,    0,    0,    0,  302,  302,  302,  302,  302,
      302,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,  302,    0,    0,  302,  302,  302,  302,  302,  302,
      303,  303,  303,  303,  303,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,  303,    0,    0,  303,
        0,    0,    0,    0,    0,    0,  303,  303,  303,  303,
      303,  303,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,  303,  303,  303,  303,  303,
      303,  304,  304,  304,  304,  304,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      304,    0,    0,    0,    0,    0,    0,  304,  304,  304,
      304,  304,  304,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,  304,  304,  304,  304,
      304,  304,  305,  305,  305,  305,  305,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,  305,    0,    0,    0,    0,    0,    0,  305,  305,
      305,  305,  305,  305,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,  305,  305,  305,
      305,  305,  305,  307,  307,  307,  307,  307,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,  307,    0,    0,    0,    0,    0,    0,  307,

      307,  307,  307,  307,  307,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  307,  307,
      307,  307,  307,  307,  312,    0,    0,    0,    0,    0,
        0,  312,  312,  312,  312,  312,  312,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      312,  312,  312,  312,  312,  312,  313,  313,  313,  313,
      313,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,  313,    0,    0,    0,    0,

        0,    0,  313,  313,  313,  313,  313,  313,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,  313,  313,  313,  313,  313,  313,  326,  326,  326,
      326,  326,    0,  326,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,  326,    0,    0,    0,
        0,    0,    0,  326,  326,  326,  326,  326,  326,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,  326,
        0,    0,  326,  326,  326,  326,  326,  326,  327,  327,

      327,  327,    0,    0,  327,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,  327,    0,    0,
        0,    0,    0,    0,  327,  327,  327,  327,  327,  327,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      327,    0,    0,  327,  327,  327,  327,  327,  327,  331,
      331,  331,  331,  331,    0,    0,    0,    0,    0,    0,
      331,    0,    0,    0,    0,    0,    0,    0,  331,    0,
        0,    0,    0,    0,    0,  331,  331,  331,  331,  331,
      331,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,  331,    0,    0,  331,  331,  331,  331,  331,  331,
      332,  332,  332,  332,    0,    0,    0,    0,    0,    0,
        0,  332,    0,    0,    0,    0,    0,    0,    0,  332,
        0,    0,    0,    0,    0,    0,  332,  332,  332,  332,
      332,  332,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,  332,    0,    0,  332,  332,  332,  332,  332,
      332,  333,  333,  333,  333,  333,    0,    0,    0,    0,
        0,    0,    0,    0,  333,    0,    0,    0,    0,    0,

      333,    0,    0,    0,    0,    0,    0,  333,  333,  333,
      333,  333,  333,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  333,    0,    0,  333,  333,  333,  333,
      333,  333,  337,    0,    0,    0,    0,    0,    0,  337,
      337,  337,  337,  337,  337,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  337,  337,
      337,  337,  337,  337,  338,    0,    0,    0,    0,    0,
        0,  338,  338,  338,  338,  338,  338,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      338,  338,  338,  338,  338,  338,  341,    0,    0,    0,
        0,    0,    0,  341,  341,  341,  341,  341,  341,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,  341,  341,  341,  341,  341,  341,  342,  342,
      342,  342,  342,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,  342,    0,    0,
        0,    0,    0,    0,  342,  342,  342,  342,  342,  342,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  342,  342,  342,  342,  342,  342,  344,
      344,  344,  344,  344,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  344,    0,
        0,    0,    0,    0,    0,  344,  344,  344,  344,  344,
      344,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  344,  344,  344,  344,  344,  344,
      361,    0,    0,    0,    0,    0,    0,  361,  361,  361,

      361,  361,  361,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,  361,  361,  361,  361,
      361,  361,  365,    0,    0,    0,    0,    0,    0,  365,
      365,  365,  365,  365,  365,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  365,  365,
      365,  365,  365,  365,  366,  366,  366,  366,  366,    0,
        0,    0,    0,    0,    0,    0,    0,  366,    0,    0,
        0,    0,    0,  366,    0,    0,    0,    0,    0,    0,

      366,  366,  366,  366,  366,  366,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,  366,    0,    0,  366,
      366,  366,  366,  366,  366,  371,    0,    0,    0,    0,
        0,    0,  371,    0,  371,    0,    0,    0,    0,  371,
      371,    0,    0,  371,    0,    0,    0,    0,  371,    0,
        0,    0,    0,    0,  371,    0,    0,    0,    0,    0,
      371,    0,  371,    0,    0,    0,    0,  371,  371,    0,
        0,  371,  376,    0,    0,    0,    0,    0,    0,  376,
      376,  376,  376,  376,  376,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  376,  376,
      376,  376,  376,  376,  377,    0,    0,    0,    0,    0,
        0,  377,  377,  377,  377,  377,  377,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      377,  377,  377,  377,  377,  377,  378,    0,    0,    0,
        0,    0,    0,  378,  378,  378,  378,  378,  378,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,  378,  378,  378,  378,  378,  378,  390,    0,
        0,    0,    0,    0,    0,  390,  390,  390,  390,  390,
      390,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  390,  390,  390,  390,  390,  390,
      391,    0,    0,    0,    0,    0,    0,  391,  391,  391,
      391,  391,  391,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,  391,  391,  391,  391,
      391,  391,  392,    0,    0,    0,    0,    0,    0,  392,

      392,  392,  392,  392,  392,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  392,  392,
      392,  392,  392,  392,  400,    0,    0,    0,    0,    0,
        0,  400,  400,  400,  400,  400,  400,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      400,  400,  400,  400,  400,  400,  401,    0,    0,    0,
        0,    0,    0,  401,  401,  401,  401,  401,  401,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,  401,  401,  401,  401,  401,  401,  417,    0,
        0,    0,    0,    0,    0,  417,  417,  417,  417,  417,
      417,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  417,  417,  417,  417,  417,  417,
      429,    0,    0,    0,    0,    0,    0,  429,  429,  429,
      429,  429,  429,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,  429,  429,  429,  429,

      429,  429,  431,  431,  431,  431,  431,    0,    0,    0,
        0,    0,    0,    0,    0,  431,    0,    0,    0,    0,
        0,  431,    0,    0,    0,    0,    0,    0,  431,  431,
      431,  431,  431,  431,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  431,    0,    0,  431,  431,  431,
      431,  431,  431,  440,  440,  440,  440,  440,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,  440,    0,    0,    0,    0,    0,    0,  440,
      440,  440,  440,  440,  440,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  440,  440,
      440,  440,  440,  440,  442,    0,    0,    0,    0,    0,
        0,  442,  442,  442,  442,  442,  442,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      442,  442,  442,  442,  442,  442,  449,    0,    0,    0,
        0,    0,    0,  449,  449,  449,  449,  449,  449,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,  449,  449,  449,  449,  449,  449,  450,    0,
        0,    0,    0,    0,    0,  450,  450,  450,  450,  450,
      450,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  450,  450,  450,  450,  450,  450,
      455,    0,    0,    0,    0,    0,    0,  455,  455,  455,
      455,  455,  455,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,  455,  455,  455,  455,
      455,  455,  456,    0,    0,    0,    0,    0,    0,  456,

      456,  456,  456,  456,  456,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  456,  456,
      456,  456,  456,  456,  461,    0,    0,    0,    0,    0,
        0,  461,  461,  461,  461,  461,  461,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      461,  461,  461,  461,  461,  461,  462,    0,    0,    0,
        0,    0,    0,  462,  462,  462,  462,  462,  462,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,  462,  462,  462,  462,  462,  462,  467,    0,
        0,    0,    0,    0,    0,  467,  467,  467,  467,  467,
      467,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  467,  467,  467,  467,  467,  467,
      482,    0,    0,  482,  482,  482,  482,  482,  482,  482,
      482,  482,  482,  483,  483,    0,  483,  483,  484,    0,
        0,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  485,  485,    0,  485,  485,  486,    0,    0,  486,

      486,  487,    0,  487,  487,    0,  487,  487,  488,  488,
      488,  488,  488,  488,  488,  488,  488,  488,  489,  489,
      489,  489,  489,  489,  489,  489,  489,  489,  489,  489,
      489,  491,  491,    0,  491,  491,  492,  492,  492,  492,
      492,  492,  492,  492,  492,  492,  493,  493,  493,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493,  494,
      494,  494,  494,  494,  494,  494,  494,  494,  494,  494,
      494,  494,  494,  496,  496,    0,  496,  496,  497,  497,
      497,  497,  497,  497,  497,  497,  497,  497,  498,  498,
        0,  498,  498,  499,  499,  499,  499,  499,  499,  499,

      499,  499,  499,  500,  500,  500,  500,  500,  500,  500,
      500,  500,  500,  501,  501,  501,  503,  503,  503,  503,
      503,  503,  503,  503,  503,  503,  504,  504,    0,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  505,
      505,  505,  505,  505,  505,  505,  505,  505,  505,  505,
      505,  505,  506,  506,  506,  506,  506,  506,  506,  506,
      506,  506,  506,  506,  506,  506,  507,  507,  507,  507,
      507,  507,  507,  507,  507,  507,  507,  507,  507,  507,
      508,  508,  508,  508,  508,  508,  508,  508,  508,  508,
      509,  509,  509,  509,  509,  509,  509,  509,  509,  509,

      510,  510,  510,  510,  511,    0,    0,  511,  511,  511,
      511,  511,  511,  511,  511,  511,  511,  513,  513,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  515,  515,  515,  515,  516,  516,  516,  516,  516,
      516,    0,  516,  516,  516,  516,  516,  516,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  519,  519,  519,  519,  519,  519,  519,  519,  519,
      519,  519,  519,  519,  519,  521,  521,  521,  521,  522,
      522,  522,  522,  522,  522,    0,  522,  522,  522,  522,
      522,  522,  523,    0,    0,  523,  523,  523,  523,  523,

      523,  523,  523,  523,  523,  524,    0,    0,  524,  524,
      524,  524,  524,  524,  524,  524,  524,  524,  525,  525,
      525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
      525,  526,  526,  526,  526,  526,  526,  526,  526,  526,
      526,  526,  526,  526,  528,  528,    0,  528,  528,  529,
      529,  529,  529,  529,  529,  529,  529,  529,  529,  529,
      529,  529,  531,  531,  531,  531,  532,  532,  532,  532,
      532,  532,  532,  532,  532,  532,  532,  532,  532,  533,
        0,    0,  533,  533,  533,  533,  533,  533,  533,  533,
      533,  533,  534,  534,  534,  534,  534,  534,  534,  534,

      534,  534,  534,  534,  534,  535,  535,  535,  535,  535,
        0,    0,  535,  535,  535,  535,  535,  535,  536,  536,
      536,  536,  536,  536,  536,  536,  536,  536,  536,  536,
      536,  537,  537,  537,  537,  537,  537,  537,  537,  537,
      537,  537,  537,  537,  538,  538,    0,  538,  538,  539,
      539,  539,  539,  539,  539,  539,  539,  539,  539,  539,
      539,  539,  541,  541,  541,  541,  542,  542,    0,  542,
      542,  542,  542,  542,  542,  542,  542,  542,  542,  543,
      543,  543,  543,  543,  543,  543,  543,  543,  543,  543,
      543,  543,  544,  544,    0,  544,  544,  544,  544,  544,

      544,  544,  544,  544,  544,  545,  545,  545,  545,  545,
      545,  545,  545,  545,  545,  545,  545,  545,  546,  546,
      546,  546,  546,    0,    0,  546,  546,  546,  546,  546,
      546,  549,  549,  549,  549,    0,    0,    0,    0,  549,
        0,    0,  549,  549,  550,  550,  550,  550,    0,    0,
        0,  550,  550,  550,    0,  550,  550,  551,  551,  551,
      551,  551,  551,  551,  551,  551,  551,  552,  552,  552,
      552,  552,  552,  552,  552,  552,  552,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481
    } ;

#line 1 "<stdin>"
YY_DECL
{
	register yy_state_type yy_current_state;
	register UChar *yy_cp, *yy_bp;
	register int yy_act;
	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 482 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 6578 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;


		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
/* rule 1 can match eol */
YY_RULE_SETUP
#line 31 "<stdin>"
{countLines(); /* ignore comments */ }
	YY_BREAK
case 2:
/* rule 2 can match eol */
YY_RULE_SETUP
#line 33 "<stdin>"
{countLines(); yyTok = WHITESPACE; return yyTok;}
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 35 "<stdin>"
{yyTok = SGML_CD; return yyTok;}
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 36 "<stdin>"
{yyTok = SGML_CD; return yyTok;}
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 37 "<stdin>"
{yyTok = INCLUDES; return yyTok;}
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 38 "<stdin>"
{yyTok = DASHMATCH; return yyTok;}
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 39 "<stdin>"
{yyTok = BEGINSWITH; return yyTok;}
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 40 "<stdin>"
{yyTok = ENDSWITH; return yyTok;}
	YY_BREAK
case 9:
YY_RULE_SETUP
#line 41 "<stdin>"
{yyTok = CONTAINS; return yyTok;}
	YY_BREAK
case 10:
YY_RULE_SETUP
#line 42 "<stdin>"
{yyTok = MEDIA_NOT; return yyTok;}
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 43 "<stdin>"
{yyTok = MEDIA_ONLY; return yyTok;}
	YY_BREAK
case 12:
YY_RULE_SETUP
#line 44 "<stdin>"
{yyTok = MEDIA_AND; return yyTok;}
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 45 "<stdin>"
{BEGIN(mediaquery); yyTok = VARIABLES_FOR; return yyTok; }
	YY_BREAK
case 14:
/* rule 14 can match eol */
YY_RULE_SETUP
#line 47 "<stdin>"
{yyTok = STRING; return yyTok;}
	YY_BREAK
case 15:
/* rule 15 can match eol */
YY_RULE_SETUP
#line 48 "<stdin>"
{yyTok = IDENT; return yyTok;}
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 49 "<stdin>"
{yyTok = NTH; return yyTok;}
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 51 "<stdin>"
{yyTok = HEX; return yyTok;}
	YY_BREAK
case 18:
/* rule 18 can match eol */
YY_RULE_SETUP
#line 52 "<stdin>"
{yyTok = IDSEL; return yyTok;}
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 54 "<stdin>"
{BEGIN(mediaquery); yyTok = IMPORT_SYM; return yyTok;}
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 55 "<stdin>"
{yyTok = PAGE_SYM; return yyTok;}
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 56 "<stdin>"
{BEGIN(mediaquery); yyTok = MEDIA_SYM; return yyTok;}
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 57 "<stdin>"
{yyTok = FONT_FACE_SYM; return yyTok;}
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 58 "<stdin>"
{yyTok = CHARSET_SYM; return yyTok;}
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 59 "<stdin>"
{yyTok = NAMESPACE_SYM; return yyTok; }
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 60 "<stdin>"
{yyTok = WEBKIT_RULE_SYM; return yyTok; }
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 61 "<stdin>"
{yyTok = WEBKIT_DECLS_SYM; return yyTok; }
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 62 "<stdin>"
{yyTok = WEBKIT_VALUE_SYM; return yyTok; }
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 63 "<stdin>"
{BEGIN(mediaquery); yyTok = WEBKIT_MEDIAQUERY_SYM; return yyTok; }
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 64 "<stdin>"
{yyTok = WEBKIT_SELECTOR_SYM; return yyTok; }
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 65 "<stdin>"
{BEGIN(mediaquery); yyTok = WEBKIT_VARIABLES_SYM; return yyTok; }
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 66 "<stdin>"
{BEGIN(forkeyword); yyTok = WEBKIT_DEFINE_SYM; return yyTok; }
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 67 "<stdin>"
{ yyTok = WEBKIT_VARIABLES_DECLS_SYM; return yyTok; }
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 68 "<stdin>"
{yyTok = WEBKIT_KEYFRAMES_SYM; return yyTok; }
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 69 "<stdin>"
{yyTok = WEBKIT_KEYFRAME_RULE_SYM; return yyTok; }
	YY_BREAK
case 35:
/* rule 35 can match eol */
YY_RULE_SETUP
#line 71 "<stdin>"
{yyTok = ATKEYWORD; return yyTok; }
	YY_BREAK
case 36:
/* rule 36 can match eol */
YY_RULE_SETUP
#line 73 "<stdin>"
{yyTok = IMPORTANT_SYM; return yyTok;}
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 75 "<stdin>"
{yyTok = EMS; return yyTok;}
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 76 "<stdin>"
{yyTok = REMS; return yyTok;}
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 77 "<stdin>"
{yyTok = QEMS; return yyTok;} /* quirky ems */
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 78 "<stdin>"
{yyTok = EXS; return yyTok;}
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 79 "<stdin>"
{yyTok = PXS; return yyTok;}
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 80 "<stdin>"
{yyTok = CMS; return yyTok;}
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 81 "<stdin>"
{yyTok = MMS; return yyTok;}
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 82 "<stdin>"
{yyTok = INS; return yyTok;}
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 83 "<stdin>"
{yyTok = PTS; return yyTok;}
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 84 "<stdin>"
{yyTok = PCS; return yyTok;}
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 85 "<stdin>"
{yyTok = DEGS; return yyTok;}
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 86 "<stdin>"
{yyTok = RADS; return yyTok;}
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 87 "<stdin>"
{yyTok = GRADS; return yyTok;}
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 88 "<stdin>"
{yyTok = TURNS; return yyTok;}
	YY_BREAK
case 51:
YY_RULE_SETUP
#line 89 "<stdin>"
{yyTok = MSECS; return yyTok;}
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 90 "<stdin>"
{yyTok = SECS; return yyTok;}
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 91 "<stdin>"
{yyTok = HERZ; return yyTok;}
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 92 "<stdin>"
{yyTok = KHERZ; return yyTok;}
	YY_BREAK
case 55:
/* rule 55 can match eol */
YY_RULE_SETUP
#line 93 "<stdin>"
{yyTok = DIMEN; return yyTok;}
	YY_BREAK
case 56:
YY_RULE_SETUP
#line 94 "<stdin>"
{yyTok = PERCENTAGE; return yyTok;}
	YY_BREAK
case 57:
YY_RULE_SETUP
#line 95 "<stdin>"
{yyTok = INTEGER; return yyTok;}
	YY_BREAK
case 58:
YY_RULE_SETUP
#line 96 "<stdin>"
{yyTok = FLOATTOKEN; return yyTok;}
	YY_BREAK
case 59:
YY_RULE_SETUP
#line 98 "<stdin>"
{yyTok = NOTFUNCTION; return yyTok;}
	YY_BREAK
case 60:
/* rule 60 can match eol */
YY_RULE_SETUP
#line 99 "<stdin>"
{yyTok = URI; return yyTok;}
	YY_BREAK
case 61:
/* rule 61 can match eol */
YY_RULE_SETUP
#line 100 "<stdin>"
{yyTok = URI; return yyTok;}
	YY_BREAK
case 62:
/* rule 62 can match eol */
YY_RULE_SETUP
#line 101 "<stdin>"
{ yyTok = VARCALL; return yyTok; }
	YY_BREAK
case 63:
/* rule 63 can match eol */
YY_RULE_SETUP
#line 102 "<stdin>"
{yyTok = FUNCTION; return yyTok;}
	YY_BREAK
case 64:
YY_RULE_SETUP
#line 104 "<stdin>"
{yyTok = UNICODERANGE; return yyTok;}
	YY_BREAK
case 65:
YY_RULE_SETUP
#line 105 "<stdin>"
{yyTok = UNICODERANGE; return yyTok;}
	YY_BREAK
case 66:
#line 108 "<stdin>"
case 67:
YY_RULE_SETUP
#line 108 "<stdin>"
{BEGIN(INITIAL); yyTok = *yytext; return yyTok; }
	YY_BREAK
case 68:
YY_RULE_SETUP
#line 109 "<stdin>"
{yyTok = *yytext; return yyTok;}
	YY_BREAK
case 69:
YY_RULE_SETUP
#line 111 "<stdin>"
ECHO;
	YY_BREAK
#line 2746 "<stdout>"
case YY_END_OF_BUFFER:
	yy_c_buf_p = yy_cp - 1;
	yy_cp = yy_c_buf_p;
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(mediaquery):
case YY_STATE_EOF(forkeyword):
	yyterminate();

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of yylex */
